#line 1 "column.c"
/* ---------------------------------------------------------------------
	Program to manipulate columns of data in a file.

	Copyright (c) 1987-1994 by CompuSource. All rights reserved worldwide.

	Version	1.2
   --------------------------------------------------------------------- */

/* ---------------------------------------------------------------------
	Include definitions of structures, constants, functions, etc.
   --------------------------------------------------------------------- */
#line 1 "\ibmcpp\include\stdio.h"
#pragma info( none )

   #pragma info( none )

#pragma info( restore )
#line 11
      extern "C" {
#line 14
   /********************************************************************/
   /*  <stdio.h> header file                                           */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/
#line 31
      typedef unsigned int size_t;
#line 34
   enum _OPERATIONS { _IOINIT, _IOREAD, _IOWRITE, _IOREPOSITION,
                      _IOFLUSH, _IOUNDEFOP };
#line 39
   #pragma pack( 1 )
   typedef struct __file       /* visible portion of the FILE struct */
      {
      unsigned char     *bufPtr;
      unsigned long int  count;
      unsigned long int  userFlags;
      unsigned long int  bufLen;
      unsigned long int  ungetCount;
      int                tempStore;
      unsigned char      ungetBuf[2];
      enum _OPERATIONS   lastOp;
      char               filler;
      } FILE;
   #pragma pack( )

   typedef struct __fpos_t      /* Definition of file positioning structure */
      {
      long int __fpos_elem[2];
      } fpos_t;
#line 83
   typedef char *__va_list;

   /* Standard stream pointers. */

   extern FILE * const stdin;
   extern FILE * const stdout;
   extern FILE * const stderr;
#line 95
   /* Function declarations. */

   int      _Optlink fprintf( FILE *, const char *, ... );
   int      _Optlink fscanf( FILE *, const char *, ... );
   int      _Optlink printf( const char *, ... );
   int      _Optlink scanf( const char *, ... );
   int      _Optlink sprintf( char *, const char *, ... );
   int      _Optlink sscanf( const char *, const char *, ... );
   void     _Optlink clearerr( FILE * );
   int      _Optlink fclose( FILE * );
   int      _Optlink feof( FILE * );
   int      _Optlink ferror( FILE * );
   int      _Optlink fflush( FILE * );
   int      _Optlink fgetc( FILE * );
   int      _Optlink fgetpos( FILE *, fpos_t * );
   char   * _Optlink fgets( char *, int, FILE * );
   FILE   * _Optlink fopen( const char *, const char * );
   int      _Optlink fputc( int, FILE * );
   int      _Optlink fputs( const char *, FILE * );
   size_t   _Optlink fread( void *, size_t, size_t, FILE * );
   FILE   * _Optlink freopen( const char *, const char *, FILE * );
   int      _Optlink fseek( FILE *, long int, int );
   int      _Optlink fsetpos( FILE *, const fpos_t * );
   long int _Optlink ftell( FILE * );
   size_t   _Optlink fwrite( const void *, size_t, size_t, FILE * );
   int      _Optlink getc( FILE * );
   int      _Optlink getchar( void );
   char   * _Optlink gets( char * );
   void     _Optlink perror( const char * );
   int      _Optlink putc( int, FILE * );
   int      _Optlink putchar( int );
   int      _Optlink puts( const char * );
   int      _Optlink remove( const char * );
   int      _Optlink rename( const char *, const char * );
   void     _Optlink rewind( FILE * );
   void     _Optlink setbuf( FILE *, char * );
   int      _Optlink setvbuf( FILE *, char *, int, size_t );
   FILE   * _Optlink tmpfile( void );
   char   * _Optlink tmpnam( char * );
   int      _Optlink ungetc( int, FILE * );
   int      _Optlink vfprintf( FILE *, const char *, __va_list );
   int      _Optlink vprintf( const char *, __va_list );
   int      _Optlink vsprintf( char *, const char *, __va_list );
#line 150
   #pragma info( none )
#line 161
         inline int getc( FILE * p )        { return fgetc( p ); }
         inline int putc( int c, FILE * p ) { return fputc( c, p ); }
#line 170
      inline int getchar( void )   { return getc( stdin ); }
      inline int putchar( int c ) { return putc( c, stdout ); }
#line 177
   /* clearerr, feof, and ferror macros - single threaded only */
#line 190
   #pragma info( restore )
#line 196
      #pragma map( fprintf, "_fprintfieee" )
      #pragma map( printf , "_printfieee"  )
      #pragma map( sprintf, "_sprintfieee" )
      #pragma map( fscanf , "_fscanfieee"  )
      #pragma map( scanf  , "_scanfieee"   )
      #pragma map( sscanf , "_sscanfieee"  )

      #pragma map( vfprintf, "_vfprintfieee" )
      #pragma map( vprintf , "_vprintfieee"  )
      #pragma map( vsprintf, "_vsprintfieee" )

      int _Optlink _fcloseall( void );
      int _Optlink _rmtmp( void );
#line 211
      FILE * _Optlink fdopen( int, const char *);
      int    _Optlink fgetchar( void );
      int    _Optlink fileno( FILE * );
      int    _Optlink flushall( void );
      int    _Optlink fputchar( int );
      char * _Optlink tempnam( char *, char * );
      int    _Optlink unlink( const char * );

      FILE * _Optlink _fdopen( int, const char *);
      int    _Optlink _fgetchar( void );
      int    _Optlink _fileno( FILE * );
      int    _Optlink _flushall( void );
      int    _Optlink _fputchar( int );
      char * _Optlink _tempnam( char *, char * );
      int    _Optlink _unlink( const char * );

      int    _Optlink _set_crt_msg_handle( int );

      #pragma map( fdopen  , "_fdopen"   )
      #pragma map( fgetchar, "_fgetchar" )
      #pragma map( fileno  , "_fileno"   )
      #pragma map( flushall, "_flushall" )
      #pragma map( fputchar, "_fputchar" )
      #pragma map( tempnam , "_tempnam"  )
#line 237
         #pragma map( unlink  , "_unlink"   )
#line 252
      }
#line 257
#pragma info( none )

   #pragma info( restore )

#pragma info( restore )
#line 1 "\ibmcpp\include\stdlib.h"
#pragma info( none )

   #pragma info( none )

#pragma info( restore )
#line 11
      extern "C" {
#line 14
   /********************************************************************/
   /*  <stdlib.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/
#line 36
     typedef unsigned short wchar_t;
#line 39
   typedef struct _div_t
       {
       int quot;        /* quotient of integer division       */
       int rem;         /* remainder of integer division      */
       } div_t;

   typedef struct _ldiv_t
       {
       long int quot;   /* quotient of long integer division  */
       long int rem;    /* remainder of long integer division */
       } ldiv_t;
#line 64
   /* function prototypes */

   int      _Builtin __abs( int );
   long int _Builtin __labs( long int );

   double   _Optlink atof( const char * );
   int      _Optlink atoi( const char * );
   long int _Optlink atol( const char * );
   double   _Optlink strtod( const char *, char ** );
   long int _Optlink strtol( const char *, char **, int );
   unsigned long int _Optlink strtoul( const char *, char **, int );
   int      _Optlink rand( void );
   void     _Optlink srand( unsigned int );
   void *   (_Optlink calloc)( size_t, size_t );
   void     (_Optlink free)( void * );
   void *   (_Optlink malloc)( size_t );
   void *   (_Optlink realloc)( void *, size_t );
   void     _Optlink abort( void );
   int      _Optlink atexit( void ( * )( void ) );
   void     _Optlink exit( int );
   char *   _Optlink getenv( const char * );
   int      _Optlink system( const char * );
   void *   _Optlink bsearch( const void *, const void *, size_t, size_t,
                              int ( * _Optlink __compare )( const void *, const void * ) );
   void     _Optlink qsort( void *, size_t, size_t,
                            int ( * _Optlink __compare )( const void *, const void * ) );
   int      _Optlink abs( int );
   div_t    _Optlink div( int, int );
   long int _Optlink labs( long int );
   ldiv_t   _Optlink ldiv( long int, long int );
   int      _Optlink mblen( const char *, size_t );
   int      _Optlink mbtowc( wchar_t *, const char *, size_t );
   int      _Optlink wctomb( char *, wchar_t );
   size_t   _Optlink mbstowcs( wchar_t *, const char *, size_t );
   size_t   _Optlink wcstombs( char *, const wchar_t *, size_t );
#line 101
      inline int abs ( int x ) { return __abs ( x ); }
      inline int labs( int x ) { return __labs( x ); }
#line 118
         void * _Builtin __alloca( size_t );
         #pragma info( none )
#line 122
         #pragma info( restore )
#line 125
      unsigned char _Builtin __parmdwords( void );

      long double _Optlink _atold( const char * );
      char * _Optlink  ecvt( double, int, int *, int * );
      char * _Optlink _ecvt( double, int, int *, int * );
      char * _Optlink  fcvt( double, int, int *, int * );
      char * _Optlink _fcvt( double, int, int *, int * );
      int    _Optlink _freemod( unsigned long );
      char * _Optlink _fullpath(char *, char *, size_t);
      char * _Optlink  gcvt( double, int, char * );
      char * _Optlink _gcvt( double, int, char * );
      int    (_Optlink _heapmin)( void );
      char * _Optlink  itoa( int, char *, int );
      char * _Optlink _itoa( int, char *, int );
      int    _Optlink _loadmod( char *, unsigned long * );
      char * _Optlink  ltoa( long, char *, int );
      char * _Optlink _ltoa( long, char *, int );
      size_t _Optlink _msize(void *);
      int    _Optlink  putenv( const char * );
      int    _Optlink _putenv( const char * );
      long double _Optlink  strtold( const char *, char ** );
      long double _Optlink _strtold( const char *, char ** );
      char * _Optlink  ultoa( unsigned long, char *, int );
      char * _Optlink _ultoa( unsigned long, char *, int );

      #pragma map( ecvt    , "_ecvt"    )
      #pragma map( fcvt    , "_fcvt"    )
      #pragma map( gcvt    , "_gcvt"    )
      #pragma map( itoa    , "_itoa"    )
      #pragma map( ltoa    , "_ltoa"    )
      #pragma map( ultoa   , "_ultoa"   )
      #pragma map( putenv  , "_putenv"  )
      #pragma map( _strtold, "strtold"  )
#line 182
         int  _Optlink _beginthread( void ( * _Optlink __thread )( void * ), void *, unsigned, void * );
         void _Optlink _endthread( void );
         void ** _Optlink _threadstore( void );
#line 187
      #pragma map( atof  , "_atofieee"   )
      #pragma map( strtod, "_strtodieee" )
#line 192
         void  _Builtin __enable( void );
         void  _Builtin __disable( void );
#line 200
               int * _Optlink _errno( void );
               #pragma info( none )

               #pragma info( restore )
#line 214
               int * _Optlink __doserrno(void);
               #pragma info( none )

               #pragma info( restore )
#line 226
         extern char **_environ;
         extern unsigned char _osmajor;
         extern unsigned char _osminor;
         extern unsigned char _osmode;
#line 236
         typedef int ( __onexit_t )( void );
         typedef __onexit_t * onexit_t;

         /* Sizes for buffers used by the _makepath() and _splitpath() functions.*/
         /* Note that the sizes include space for null terminating character.    */
#line 248
         void          _Optlink _exit( int );
         onexit_t      _Optlink  onexit( onexit_t );
         onexit_t      _Optlink _onexit( onexit_t );
         unsigned int  _Optlink _rotl (unsigned int, int);
         unsigned int  _Optlink _rotr (unsigned int, int);
         unsigned long _Optlink _lrotl(unsigned long, int);
         unsigned long _Optlink _lrotr(unsigned long, int);
         void          _Optlink _makepath( char *, char *, char *, char *, char * );
         void          _Optlink _splitpath( char *, char *, char *, char *, char * );
         void          _Optlink _searchenv( char *, char *, char *);
         void          _Optlink  swab( char *, char *, int );
         void          _Optlink _swab( char *, char *, int );

         #pragma map( onexit , "_onexit"  )
         #pragma map( swab   , "_swab"    )

         /* Define different memory model versions of memory management       */
         /* routines to the standard names.                                   */
#line 295
      }
#line 300
#pragma info( none )

   #pragma info( restore )

#pragma info( restore )
#line 1 "\c2cpp\sample\column.h"
typedef	int	BOOL;
#line 6
void	error_handler(unsigned int errnum, char *message);
int	read_param(char **param, int defolt);
#line 1 "\c2cpp\sample\fileio.h"
typedef	struct	{
	FILE*		hFile;
	char*		pchBuffer;
	int		iRecLen;
	char*		pchRecord;
	BOOL		fTextMode;
}	FILEIO;

void	buffers(FILEIO* pFile, char *pszFilename, BOOL fRead, int iRecLen, BOOL fTextMode);
BOOL	read_record(FILEIO *pFile);
void	write_record(FILEIO *pFile, const char *pchOutput, int iRecLen);
void	FileIOCleanup(FILEIO* pFile);
#line 1 "\c2cpp\sample\params.h"
typedef	struct	{
	BOOL		fQuestion;
	BOOL		fTextMode;
	int		iRecLen;
	int		iStartLine;
	int		iEndLine;
}	PARAMS;

void	defaults(PARAMS* pParams);
int	ParamsSetup(PARAMS* pParams, int argc, char** argv);
BOOL	in_range(PARAMS* pParams, int value);
#line 1 "\c2cpp\sample\transfrm.h"
typedef	struct	{
	int		iNewRecLen;
	int*		piOriginal;
	int*		piPermute;
	char*		pchSet;
	char*		pchValues;
}	TRANSFORM;

void	TransformInitialise(TRANSFORM* pTransform, int iRecLen, int iNewRecLen);
void	TransformSetup(TRANSFORM* pTransform, int iRecLen, int argc, char** argv);
void	TransformRecord(TRANSFORM* pTransform, const char *pchInput, char *pchOutput, BOOL fTextMode);
void	TransformCleanup(TRANSFORM* pTransform);
#line 21 "column.c"
/* ---------------------------------------------------------------------
	Locally used variables.
   --------------------------------------------------------------------- */

PARAMS		params;
TRANSFORM	transform;
FILEIO		inFile;
FILEIO		outFile;

/* ---------------------------------------------------------------------
	Produce the appropriate error message and abort execution.
   --------------------------------------------------------------------- */

const char	*err_msgs[] = {
/*  0 */	"Unknown error",
/*  1 */	"Unable to open file",
/*  2 */	"Could not assign a file buffer for file",
/*  3 */	"Unable to close file",
/*  4 */	"Insufficient memory for",
/*  5 */	"Unknown command line specifier",
/*  6 */	"End point must not be smaller than start",
/*  7 */	"Cannot make limited range changes if record size alters",
/*  8 */	"Overlapping column requirements",
/*  9 */	"Column range outside limits of input file",
/* 10 */	"Unable to process sufficient information for",
/* 11 */	"Error with column permutation discovered during",
		};

void	error_handler(unsigned int errnum, char *message)
{
	fprintf(stderr,"%s: %s\n",
		err_msgs[(errnum < 1 || errnum > 11) ? 0 : errnum],
		(message == 0) ? "" : message);
	fprintf(stderr,"Type COLUMN for help information\n");
	exit(errnum);
}

/* ---------------------------------------------------------------------
	Display help on how to use the program. Exit program afterwards.
   --------------------------------------------------------------------- */

void	help(void)
{
	fprintf(stderr,
		"Usage:\tCOLUMN infile outfile Q Tl/Fl Lr1,r2 [Rc1,c2,Cc/Mc/D/Z/B/Sx]\n"
		"\nwhere\tQ\t= don't execute, but show how transformed\n"
		"\tT/F\t= text file or fixed length data file\n"
		"\tl\t= maximum record length (maximum 32000)\n"
		"\tL\t= specification of which lines to operate on\n"
		"\tr1,r2\t= inclusive range of lines (records)\n"
		"\tR\t= specification of column range and action\n"
		"\tc1,c2\t= inclusive range if columns\n"
		"\tC/M/D\t= whether to copy & insert, move or delete the columns\n"
		"\tc\t= new column location if copy or move\n"
		"\tZ/B/S\t= whether to zero, blank or set the columns\n"
		"\tx\t= new column values i.e. number,number,number,...\n"
		"\nExample\tcolumn in out R1,5,D R6,10,C1\n"
		"\tcolumn in out L20,29 F40 R31,40,M11 R1,3,S1,0,0\n"
		"\nNotes:\tA column range specification must be given.\n"
		"\tMore than one column range may be specified.\n"
		"\tThe input file must be different to the output file.\n"
		"\tDefaults are text mode, l = 255, all records.\n"
		"\tSpecifications may be given in any order.\n"
	);

	exit(99);
}

/* ---------------------------------------------------------------------
	Read the value of a parameter and update the string pointer.
	The arguments are:
		param		=	pointer to char pointer of parameter (modified)
		default	=	default value if parameter non-existent or zero.
	Return value is the parameter (or its default if zero).
   --------------------------------------------------------------------- */

int	read_param(char **param, int defolt)
{
	long	actual;

	actual = strtol(*param, param, 10);
	if (**param != '\0') (*param)++;

	return (actual == 0) ? defolt : actual;
}

/* ---------------------------------------------------------------------
	Process the command line arguments.
	Valid specifications are for:
		text / fixed length files
		record numbers to process
		column ranges and what to do with them.
	No return value.
   --------------------------------------------------------------------- */

void	arguments(int argc, char **argv)
{
	int	iNewRecLen;

	/*	read the main parameters and initialise the transformation tables */

	iNewRecLen = ParamsSetup(&params, argc, argv);

	TransformInitialise(&transform, params.iRecLen, iNewRecLen);

	/*	work out the permutation table and which columns to modify */

	TransformSetup(&transform, params.iRecLen, argc, argv);
}

/* ---------------------------------------------------------------------
	Show the user how the file's columns will be transformed.
   --------------------------------------------------------------------- */

void	show(TRANSFORM* pTransform, PARAMS* pParams)
{
	int	i, iMax;

	iMax = pTransform->iNewRecLen;
	if (pParams->fTextMode) {
		iMax = 0;
		for (i=pTransform->iNewRecLen-1; i>=0; i--) {
			if (pTransform->pchSet[i] || (pTransform->piPermute[i] != i+1)) {
				iMax = i+1;
				break;
			}
		}
	}

	if (iMax == 0) {
		printf("No column translation will occur!\n");
		return;
	}

	printf("New col #   Old col #   Set to\n");
	for (i=0; i<iMax; i++) {
		printf("  %5u     ", i+1);
		if (pTransform->pchSet[i])
			printf("             %3u\n", pTransform->pchValues[i]);
		else
			printf("  %5u\n", pTransform->piPermute[i]);
	}

	if (iMax < pTransform->iNewRecLen) {
		printf("      :           :\n  %5u       %5u\n", pTransform->iNewRecLen, pTransform->iNewRecLen);
	}
}

/* ---------------------------------------------------------------------
	Read and process each record in turn.
   --------------------------------------------------------------------- */

void	process(void)
{
	int	recnum = 0;

	while (read_record(&inFile)) {
		recnum++;
		if (in_range(&params, recnum)) {
			TransformRecord(&transform, inFile.pchRecord, outFile.pchRecord, params.fTextMode);
			write_record(&outFile, outFile.pchRecord, outFile.iRecLen);
		}
		else {
			write_record(&outFile, inFile.pchRecord, inFile.iRecLen);
		}
	}
}

/* ---------------------------------------------------------------------
	Close all files and free dynamically allocated memory.
	The arguments are:
		fFiles	=	says whether to close files
	No return value.
   --------------------------------------------------------------------- */

void	goodbye(BOOL fFiles)
{
	if (fFiles) {
		FileIOCleanup(&inFile);
		FileIOCleanup(&outFile);
	}

	TransformCleanup(&transform);
}

/* ---------------------------------------------------------------------
	The main entry point of the COLUMN program.
   --------------------------------------------------------------------- */

int	main(int argc, char **argv)
{
	fprintf(stderr,
		"\nCOLUMN manipulation program\n"
		"\nCopyright (c) 1987-1994 by CompuSource. All rights reserved worldwide.\n\n"
	);

	if (argc < 4) help();

	defaults(&params);
	arguments(argc, argv);

	if (params.fQuestion) {
		show(&transform, &params);
	}
	else {
		buffers(&inFile,	argv[1], 1,		params.iRecLen,			params.fTextMode);
		buffers(&outFile,	argv[2], 0,	transform.iNewRecLen,	params.fTextMode);
		process();
	}

	goodbye(params.fQuestion == 0);

	return 0;
}
